Overview

Diagram Designer | Overview

Description

Diagram Designer is a tool for creating flowcharts, diagrams or slide shows (eg. for an overhead projector). The program excels at creation of technical diagrams and allows for easy editing and object manipulation.

Features (partial list)

  • Freeware! (user supported) - as of this date
  • Customizable templates which house often used pictures, symbols or objects
  • Group objects together as a single entity
  • Spellchecker for text used in diagrams
  • Automatic links between objects - move one object, the other is adjusted
  • Import objects or export diagrams as:
    □ BMP Windows® Bitmap
    □ CUR Windows® Cursor
    □ EMF Windows® Enhanced MetaFile
    □ GIF Graphics Interchange Format
    □ ICO Windows® Icon
    □ JP2 JPEG 2000 (requires Image Analyzer installed)
    □ JPG Joint Picture Expert Group
    □ MNG Multiple-image Network Graphics
    □ PCX Zsoft Paintbrush
    □ PNG Portable Network Graphics
    □ TIF TIFF image (requires Image Analyzer installed)
    □ WMF Windows® MetaFile
  • use multiple layers and pages in a single diagram
  • Slide show viewer (view sequential pages)
  • Preview mode
  • Optional snap mode with visible or invisible grid
  • Graph plotter to plot mathematical expressions
  • Compressed file format for minimizing drawing file size
  • Advanced pocket calculator with equation solver
  • MeeSoft Image Analyzer integration for bitmap image editing and extended file format support - separate package

Using this file

This file contains tools which may help in locating information about Diagram Designer. In order of ease of use, try:

  • Contents tab - this itemizes each page in the document
  • Index - some (but not all!) topics have been itemized in the index
  • Search - this document contains a full text searchable database - see Using Search Effectively
  • The navigation pane also contains a Favorites tab - you make save your favorite locations in this document for easy reuse.

This manual was prepared by Allen Titley, BCLS (atbcls@direct.ca), British Columbia, Canada
Last edited January 8, 2006.


License Information

Diagram Designer | License Information

Conditions for using and copying the software:

  • I (Michael Vinther) or MeeSoft can not in any way be held responsible for any damage or loss caused by using this software.
  • The software can only be copied/distributed in its original form (installer or zip archive) unless otherwise agreed with the author.
  • Distribution of this software for commercial purposes is not allowed without consent from the author.

Thanks to Markus Oberhumer and Laszlo Molnar for their brilliant EXE compressor UPX. (See http://upx.sourceforge.net/)

AutoRealm symbols are used with permission of Andy Gryc. They are free and may not be sold. AutoRealm is a GNU copyrighted program for making maps used in role playing games. AutoRealm is available at: http://autorealm.sourceforge.net/index.html

Electronic symbols by Schelte Heeringa.


Installation and Startup

Diagram Designer | Installation and Startup

Installation

Diagram Designer is delivered in an installer package (or wrapper) or as a zip archive. Installation consists of

Installer package | Simply run the EXE file (eg. DiagramDesignerSetup.exe) and follow the instructions. You will be asked questions about file associations; use defaults for now. The installer creates a Start menu item and all necessary sub-items, as well as a convenient uninstaller (from Control_Panel/Add_or_Remove_Programs). This method of installation is preferred.
ZIP archive | The ZIP archive contains all the same files as the installer package, with the exception of files connected with uninstall. To install, create a directory (suggested is Program_Files/Diagram_Designer) and unzip the files to that directory. Make sure that you specify "create subfolders", if required, since the example files are destined for a separate subdirectory. You may execute DiagramDesigner.exe directly, or create the necessary Windows® shortcuts.

Diagram Designer creates and uses Windows® registry entries under
 HKEY_CURRENT_USER/Software/MeeSoft
That entry could be removed for a complete manual uninstall, but there may also be entries for Image Analyzer which will be deleted..

Startup

Diagram Designer may be run by

  • direct execution of DiagramDesigner.exe (double-click from Explorer, or use Start/Run), or

  • execution of a created shortcut (created by installer or manually.

In addition, Diagram Designer can accept 1 or 2 optional parameters from the command line (or as part of a shortcut) as in:
DiagramDesigner<.exe> <default_diagram.ddd> <default_template.ddt>
where < > specifies optional components.

If, for example, you wish to create a shortcut to automatically load the Flowchart template, perform the following:

  1. Create an ordinary Windows® shortcut to DiagramDesigner.exe

  2. Edit the shortcut's Properties to add the Flowchart.ddt parameter. It is assumed that Flowchart.ddt is located in the DiagramDesigner folder, along with DiagramDesigner.exe.

  3. If desired, the Run: parameter in the shortcut can be changed to Maximized. A Shortcut key could also be added.

In the image beside, the Target should be:
"G:\Program Files\MeeSoft\DiagramDesigner\DiagramDesigner.exe" flowchart.ddt
Note that the parameter is outside the double quoted path to the executable.

For administrators only:

If you wish to create an association to automatically load .ddd files AND the Flowchart template, edit the Explorer File-Type Properties to add the full path to Flowchart.ddt. The full path is outside the double quoted path to the executable. Type the full path at the end of the command line (you mustn't use DDE). Default associations must be previously created by the program options.
Tools - Directory Options - File-Types tab.
Select the extension, click Advanced and edit the Open item (set it as default).


Version History

Diagram Designer | Version History

Note that this version history is incomplete. It does not include all changes in all versions.

Version Date Comments
1.21 2008-10-14
  • UML class diagram symbols
  • Line start/end marker can be changed in toolbar
  • Print scaling setting
  • Link point markers (red x) only shown while dragging an object
  • New improved antialiasing algorithm
  • Object shadows option
  • Find text function
1.20 2008-03-16
  • Improved Vista support
  • Diamond line end style
  • Line segments style for curve lines
  • New outline connector style
  • Scaling anchors on objects in group to support scaling of a group
  • Bitmap alpha blending (cannot be used with halftone scaling)
  • Antialiasing in slide show and bitmap export
  • Text formatting bugfix
  • Easier editing of link points using the mouse
1.19 2007-06-05
  • Closed curve can be converted to polygon and filled
  • Preview of template palettes in load dialog
  • Preview/thumbnails of diagrams in Explorer
  • Flowchart palette based on the work of Allen Titley and Alessandro Visentin and others
  • Move up/down buttons in link editor
  • Template palette remembered from last run
1.18 2006-12-30
  • Ctrl+arrow keys move selected objects by one grid unit
  • Ctrl+Alt+arrow keys move selected objects by one screen pixel
  • Layer menu can be opened from the status bar
  • New menu shortcut system: Just begin typing the name of the menu item or press F10
  • Fixed bug in formatting of text with different font sizes and multiple lines
  • Radius property on rectangles and connectors (only works with solid line style)
  • Symmetrical resizing of objects using the Shift key (press Shift AFTER pressing the mouse button on a corner)
  • Fixed bug with text on objects related to multi-byte character sets
1.17 2006-09-26
  • Resizing of group objects
  • Anchors on grouped objects for use when resizing
  • GUI design palette
  • Screen saver disabled during full screen slide show
1.16 2006-06-06
  • New text translation system with plain text language files
  • User interface updates
  • Popup note text attribute (\N)
  • A number of bugfixes
1.15 2006-01-07
  • Text color (\C) attribute
  • Improved BMP and JPEG import
  • Better handling of "Large fonts" setting in Windows
  • New program help file
1.14 2005-08-12
  • Links between pages (\Apage)
  • User interface updates
  • Underline (\U) and overline (\O) text
  • Improved text editing dialog
1.13.2 2005-02-06
  • Preview bugfix
1.13 2005-01-23
  • Links between documents (\Afilename.ddd)
  • Text margin
  • User interface updates
1.12 2004-08-07
  • Problem with graph plotter in expression evaluator fixed
  • Link point deletion bugfix
  • Non-Latin characters in translation supported
  • Windows® XP theme support
1.11 2004-05-31
  • GIF import/export
  • Double arrow type
  • Minor improvements
1.09 2004-03-18
  • Slide show capabilities
  • More keyboard shortcuts
  • Option to align objects to page or selection boundaries
  • Spell checker
  • Rotation (only implemented for some object types)
1.00 2004-02-19
  • Double-click object to edit text
  • Multiple connected lines can be drawn by left/right clicking while drawing
  • Object style editing in tool bar
0.99 2004-01-24
  • Connect links option
  • Connections marked with green boxes when objects are selected
0.98 2004-01-15
  • Paste special option
  • Text objects no longer has a link point
  • Font name and size can be changed in text labels
  • Template palette can be edited as normal diagram page
  • New line styles
  • Holding Ctrl while editing changes edit mode for lines, shapes and pictures
  • Holding Alt while editing will disable "snap to grid"
0.97
 2003-12-26
  • Expression evaluator precision and plot axis auto-scaling improved
  • Import MNG pictures
  • New text alignment options
  • Language module
0.96 2003-12-06
  • New page properties dialog
  • Default line width changed to 3/4 point
0.94 2003-11-25
  • Multi-layer designs
  • Automatic renaming of objects to match text
  • Additional object shapes
0.92 2003-11-12
  • All objects/text can be converted to metafile objects
  • Rotation of metafile objects
0.91 2003-11-08
  • Object tree display
  • Curve object type
0.90 2003-10-25
  • First public release


Main Screen

Diagram Designer | Main Screen

Click on an item for more information
Object Tree Diagram Template Menu Toolbar Status area

The main screen is comprised of 6 distinct areas:

  • Menu,
  • Toolbar,
  • Object Tree pane (optional),
  • Diagram pane,
  • Template pane and
  • Status area

Menu

The Diagram Designer main menu has 5 components:

  • File
  • Edit
  • Diagram
  • Object
  • Help

Individual parts of each menu are discussed on a separate page.

Object Tree pane

The Object Tree pane shows all current objects in the diagram. Objects are identified by (user assigned) name; groups are represented just as an expandable Group, with the individual objects shown (including other groups) when the Group name is expanded. Selecting an object in the Object Tree also selects in the Diagram Pane, unless that object is part of a Group. In a similar manner, selecting an object in the Diagram pane selects the object in the Object Tree pane.

The Object Tree can be toggled on/off in the Object menu. Object properties can be accessed from the Object Tree either by double-clicking the object, or by opening Properties... in the Object menu. The object tree can be larger than the pane allows - Windows® sliders will appear to access the entire tree.

Note that the Object Tree pane can be resized by dragging the divider between the Object Tree and Diagram panes.

Diagram pane

The Diagram pane is where all the work is done; actual creation of the diagram is done here. The Diagram pane is considered to be a blank page (size etc. determined by the user) on which the diagram is drawn by dragging objects from the template. Objects can be resized (most objects) and moved, once placed in the Diagram pane and, as well, their properties can be edited from her (eg. color, linetype, etc.). For extra sensitivity in movement, etc., the Diagram pane can be zoomed (in or out - using the scale combo box or the magnifier, both in the toolbar), thereby changing the visual scale and allowing finer movement, etc. The diagram can be larger than the pane allows - Windows® sliders will appear to access the entire diagram.

Note that the Object Tree pane can be resized by dragging

  • the divider between the Object Tree and Diagram panes, or
  • the divider between the Diagram and Template panes.

Template pane

The Template pane (or Template Palette) contains objects for placement on the Diagram pane. Templates can be either

  • standard - loaded automatically at startup - contains basic shapes, lines and arrows, or
  • custom - the user can create objects to suit a particular application, then turn those objects (from the Diagram pane) into a template.

Templates can be changed at any time during diagram construction. The template can be larger than the pane allows - Windows® sliders will appear to access the entire template.

Note that the Object Tree pane can be resized by dragging the divider between the Diagram and Template panes.

Status Area

The status area show 2 basic pieces of information:

  • the current page - Diagram Designer can operate on multiple pages as part of the same diagram. Left-clicking on the current page allows access to other page features.
  • the current cursor coordinates - coordinates are shown in the units set by the Options menu (File/Options). Coordinates are only valid for the Diagram pane.


File Menu

Diagram Designer | File Menu

Click on an item for more information

New...
  • opens a new diagram using a standard Windows® dialog. Dialog prompts to save any existing diagram, if necessary. Opens the Page Properties dialog to allow setup for a new page (size, etc.).

Open
  • opens a standard Windows® dialog for selecting an existing diagram (.DDD) file.

Open in new window
  • opens a existing diagram, but as a new process (ie. second copy of Diagram Designer). Diagram Designer does not currently support the Windows® MDI (multiple document interface), so a second diagram must be handled as a separate process.

Reload
  • re-opens the existing diagram, but from the disk file. If changes have been made to the existing diagram (but not saved), a warning dialog is opened to allow cancelling the reload operation.

Save
  • opens a standard Windows® dialog to save the existing diagram file (if not previously saved), or just re-saves the existing file (if already saved/named).

Save as...
  • opens a standard Windows® dialog to save the current diagram, but always requires a name. In this manner, the existing (named) diagram can be renamed to a different file.

Export page...
  • opens a Save dialog to save the current diagram as an image file. Currently, Diagram Designer supports the following image formats:
□ BMP Windows® Bitmap
□ CUR Windows® Cursor
□ EMF Windows® Enhanced MetaFile
□ GIF Graphics Interchange Format
□ ICO Windows® Icon
□ JP2 JPEG 2000 (requires Image Analyzer installed)
□ JPG Joint Picture Expert Group
□ MNG Multiple-image Network Graphics
□ PCX Zsoft Paintbrush
□ PNG Portable Network Graphics
□ TIF TIFF image (requires Image Analyzer installed)
□ WMF Windows® MetaFile

After the image format is specified, Diagram Designer prompts for the image resolution in DPI (dots per inch). The default is 96 (resulting in the full page size, as chosen by the user using page properties), but Diagram Designer allows for a range of 64 to 2400 dpi.

If, for example, the current page size is 4.25 inches x 5.50 inches (1/4 of a letter sheet), Diagram Designer will create images of the following sizes, depending on the DPI selected:

DPI entered | Image size
96 | 4.25" x 5.50"
64 | 2.83" x 3.67"
192 | 8.5" x 11"

Note that when exporting the diagram to an image file, ALL layers on the current page, whether currently visible (as determined by which layer is being edited) or not, are exported to the final image file. Inherited layers are also exported. In other words, the final image is the same as that shown in Preview mode.

Print...
  • opens the standard Windows® print dialog, allowing the user to print the current diagram.

Preview mode
  • invoking preview mode simply does the following
    • changes the page background to white
    • hides the grid, if currently showing
    • displays all layers

This allows the user to view the current diagram as a finished page, displaying all layers on the current page, whether currently visible (as determined by which layer is being edited) or not. The Preview icon changes to reflect the current mode [image].

Slide show
  • initiates a slide show, presenting pages in fullscreen mode with a white background and without displaying the grid. If the diagram contains more than a single page, left-clicking anywhere on the page advances the slide show to the next page.

Right-clicking on the page (during a slideshow) brings up the context menu which allows the user to control the slideshow (ie. jump to a page, etc.). Pressing Esc (escape) terminates the slideshow and returns to the previous mode (usually regular edit mode).

Template Palette ►
  • opens the template palette menu allowing the user to perform operations on the Template pane. The following options are available:
    • Load - loads a new template file (DDT) to the template pane.
    • Save - saves the template pane as a template file.
    • Copy - copies all template objects to the Diagram pane.
    • Make - converts the current diagram layer (visible) to a template. Note that the template is not saved as a file; the diagrams objects are simply placed in the Template pane.

Options
  • Sets global program options - see separate page.

Close
  • closes Diagram Designer, invoking the file save dialog, if necessary.


Options

Diagram Designer | Options

Click on an item for more information

Grid
  • sets the grid spacing (X and Y) using the current units, as set below
  • toggles grid visibility on/off (Show grid)

Note that even when grid is toggled off (ie. clear the Show grid tick), the grid snap mechanism is still in effect. To effectively turn the grid snap off, set the grid spacing (X and Y) to 0.0. Setting a small grid spacing may cause the grid to not appear unless the zoom factor is increased.

Diagram Designer's snap feature causes object link points and bounding box link resize points to automatically align to a grid point, when that point is close to the link point or resize point. This makes alignment and sizing of objects easier most of the time. Holding down the <Alt> key disables the snap feature so that an object can be resized or moved without interference from the snap feature.

Units
  • set units as
    • Millimeters
    • Centimeters
    • Inches
    • points (1 pt. = 1/72 inches)
    • 300 DPI dots
    • 600 DPI dots

    Once units are set all page and object properties are presented in those units, except for line widths and margins (presented in pts. or 1/4 pts.).

Clipboard metafile scale
  • When objects are copied to the clipboard (as a Windows® metafile), this value (default = 1) controls how large the objects are when pasted into another application as a metafile image. Setting this value to 2, for example, pastes the metafile as twice normal size into a document (eg. using Wordpad).

Undo history size
  • This value controls how many operations (eg. move, edit properties) will be remembered and are available for undo. Setting this value lower than default (20) frees up memory used by the undo mechanism, but might make editing and diagram creation more difficult or less versatile.

Set program language
  • Diagram Designer is designed for English usage, but (with the installation of the Language pack), other languages can be installed. The Language pack provides program translations for:
    • Czech
    • Danish
    • Dutch
    • English (built in)
    • Estonian
    • French
    • German
    • Italian
    • Polish
    • Portuguese
    • Spanish

Once a language has been selected, the program must be restarted in order for the new language to take effect.

If you are experiencing problems with display of local character sets in the software translations, this may be due to incorrect Windows character set setting. In Windows XP you can check this by opening Regional and Language Options in Windows' Control Panel and going to the Advanced tab. Verify that the proper language is selected for non-Unicode programs:

File format associations

  • During installation of Diagram Designer (using the installer package), this dialog is presented to allow Windows® file associations for:
    • .DDD files - Diagram Designer diagrams, and
    • .DDT files - Diagram Designer templates

    If these associations are created (either at installation time, or by using this dialog later) double-clicking on one of the above files will open Diagram Designer and load the file accordingly. Disabling one or both of the entries using the dialog will break the association between those files and Diagram Designer - they will not load on a double-click. When enabling the associations, if the Description box is checked (checked is the default value), Windows® Explorer shows DDD and DDT files as "Diagram" and "Diagram template palette", respectively, rather than just "DDD file" or "DDT file".

    Note that the uninstall process for Diagram Designer (assuming the install package was used) eliminates 2 of the 4 Windows® registry entries for file associations only. For complete removal, the user should also remove the following entries:
    HKEY_CLASSES_ROOT\.ddd, and
    HKEY_CLASSES_ROOT\.ddt
    following completion of the uninstall process.

Set dictionary path
  • Diagram Designer's spell check feature cannot be enabled unless a dictionary is installed. This item allows the user to specify the path to any installed dictionary files. Although only the folder path is used, the user must select a valid dictionary file in that folder. Links to dictionaries are available at http://meesoft.logicnet.dk/DiagramDesigner/.


Edit Menu

Diagram Designer | Edit Menu

Click on an item for more information

Undo
  • undo last operation (eg. cut, paste, move, etc.). Objects affected by the last operation are restored to their previous state. The number of undo operations available (ie. Undo history size) is set in the Options dialog (ie. File/Options).

Redo
  • redo the last undo. If undo was used, this operation restores the objects to their state before the undo was executed.

Select all
  • selects all objects in the Diagram pane.

Cut
  • cuts the selected object(s) to the clipboard - objects are removed from the diagram. Note that Windows® provides a native keyboard shortcut of Ctrl+X for this function. Users may find this more convenient as it is a one-handed combination.

Copy
  • copies the selected object(s) to the clipboard - objects are left intact. Note that Windows® provides a native keyboard shortcut of Ctrl+C for this function. Users may find this more convenient as it is a one-handed combination.

Paste
  • pastes the clipboard contents (object or objects) to the diagram. Objects are pasted near the original (if copied or cut from the diagram) and may be moved to another position. Diagram Designer can also paste text or images copied to the clipboard by other applications; images are inserted as bitmaps regardless of their original format. Such objects are pasted near the current top of the Diagram pane. Note that Windows® provides a native keyboard shortcut of Ctrl+V for this function. Users may find this more convenient as it is a one-handed combination.

Paste special
  • If Diagram Designer does not completely understand the format of data in the clipboard, the Paste special routine should allow the user to paste the data anyway, converting it to a different format. For example, copying colored text from a word processor likely puts Rich Text format text in the clipboard. Attempting to use Paste in Diagram Designer just pastes the (uncolored) text, while using Paste special allows the user to choose between Text and Windows® metafile format. The metafile format, although restrictive in editing capability (by Diagram Designer) does show the text as originally colored.

Delete
  • deletes an object or objects without copying them to the clipboard. Objects removed in this fashion can be re-instated by using undo.

Insert picture...
  • this tool allows insertion of a picture as a bitmap. Although similar to Paste (or Paste special), it differs in that copying the image to the clipboard is not necessary; the image file can be imported directly.

Insert inherited layer...
  • see Using layers for a discussion of layering and inserting an inherited layer.


Diagram Menu

Diagram Designer | Diagram Menu

Click on an item for more information

Spell checker...
  • Diagram Designer can check the spelling of all text. The spell checker is covered on a separate page.

Default font...
  • opens a standard Windows® dialog to select the default font for text in objects. Text in objects can over-ride the default and use a different font, if desired. At startup, Diagram Designer uses the Arial font, 10pt. text as a default; setting a new default font applies that font on a drawing by drawing basis only.

Page properties...
  • opens a dialog to set properties (ie. page size) for the current page. The user can manually set the page width and height in current units as determined by the Options settings or use the settings already available to the printer ( [image]). The [image] button reverses the width and height settings, if desired. If multiple pages exist in the diagram, the settings can be applied to all pages by checking the Apply to all pages box.

This dialog is also available by left-clicking the current page name shown in the status area.

New page
  • creates and opens a new page in the diagram. Page name is always "Page n", numbered as 1 being the first page (regardless of whether it has been renamed). This feature is also available by left-clicking the current page name shown in the status area.

Rearrange pages...
  • opens a dialog allowing the user to
    • rename pages
    • re-order pages
    • delete pages
    • select the current page

    This dialog is also available by left-clicking the current page name shown in the status area.

Edit layer ►
  • This operation allows the user to select the current layer. Only the current layer can be edited. See Using Layers for more information.

Connect links
  • When link points contained in different objects occupy the same location, the usual behaviour is for the links to connect. This effectively joins the two (or more) objects such that, if one is moved, the other(s) move also. However, this linking does not always occur; this operation attempts to join all links on the page which should have been linked upon creation.

Set layer color...
  • sets the default color for a layer. See Using Layers for more information.


Spell Check

Diagram Designer | Spell Check

Diagram Designer's spell check tool checks spelling of all text in objects. Spell check requires that a valid dictionary be installed, and that the dictionary path is set in the Options dialog; an error message will result if no dictionary is found.

The initial dialog shows the default language (changeable if more than one dictionary is installed) and some spell check options, namely:
  • Check only the active layer - if box is unchecked, all layers will be checked.
  • Skip symbols - don't try to spell check non-words (eg. mathematical symbols, etc.)

Once options are set, the [image] button will commence the spell check.

If the spell checker finds a mis-spelled word (as in the image to the right), the user is presented with a detailed list of possible correct spellings. 3 choices exist at this time:
  1. the word is spelled correctly; press [image] to add the word to the dictionary. New words added to the dictionary are not added to the main dictionary file; a separate file is created (eg. english.user.dic) which may be edited or deleted.
  2. highlight the correct spelling from the Suggestions box, and press [image] to replace the word
  3. type a new spelling the the top-most box (Not in dictionary:) and press [image] to replace the word

The spell check tool issues a message when complete, press [image] to close the dialog.


Object Menu

Diagram Designer | Object Menu

Click on an item for more information

Properties...
  • opens a dialog to edit and object's (or objects') properties. This menu item is only available when at least one object is selected. Properties available for editing depend on the object type. See Object Properties for more information.

Edit text...
  • opens a dialog to edit an object's text. Although more than one object can be selected, only a single object's text is affected - for predictable behaviour, only select a single object. See Editing Text for more information.

Bring to front
  • When objects overlap, one object may obscure the other, particularly if the object has a solid fill. Using this tool brings the selected object(s) to the front, giving the appearance that the selected objects are on top of the formerly obscuring object. This behaviour is opposite to Send to back.

Send to back
  • When objects overlap, one object may obscure the other, particularly if the object has a solid fill. Using this tool sends the selected object(s) to the back, giving the appearance that the other objects are on top of the selected object(s). This behaviour is opposite to Bring to front.

Group
  • This tool groups selected objects together, allowing them to behave as a single object. Once objects are grouped together, they may be moved as a single object, but individual object properties are no longer available. Link points associated with the former individual objects are also no longer applicable, although the user may assign new link points to the grouped object. Note that groups may be nested; grouped objects may be collectively grouped.

Ungroup
  • Objects that have been grouped together are separated (back to individual objects) by this tool. Individual properties for each object are restored and may be edited. If the original grouped object was a collection of groups, rather than objects, only the separate groups are restored by ungroup.

Rotate ►
  • attempts to rotate selected object(s). Rotation of some objects may yield unpredictable results, especially polygons, etc. While the general shape of the object may be rotated, any link points (already linked to other objects) may not be as expected after rotation. Converting an object to a Windows® metafile object will enable all rotations (ie. any angle) to be done, but original object properties are no longer available. Objects converted to a metafile cannot be converted back to objects - use metafile conversion with caution.

    Mirroring objects (left to right) will mirror any embedded text also (rendering it unreadable). Likewise, Flipping objects (top to bottom) affects embedded text.

Align ►
  • allow the user to align object(s) relative to the current page. The following settings are available
    • Left - shift to left edge, preserve vertical location
    • Center (horizontally) - center on page, preserve vertical location
    • Right - shift to right edge, preserve vertical location
    • Top - shift to top edge, preserve horizontal location
    • Center (vertically) - center on page, preserve horizontal location
    • Bottom - shift to bottom of page edge, preserve horizontal location
    • Fill - expand object to full page.

    If more than 1 object is selected, Diagram Designer tries to align one (or more) object to meet another. In general, the objects are aligned with that (selected) object closest to the final alignment location. If Fill is used, one or more objects will try to fill another, with somewhat unpredictable results.

Convert to polygon
  • converts a collection of objects to a polygon, one of Diagram Designer's composite objects. The procedure for conversion is as follows:
    1. | Draw the outline using simple lines. In this example we will make a simple filled triangle.
    2. | Select all lines. Lines must be connected with no gaps in the shape. Use Diagram/Connect links, if necessary, to ensure lines are connected.
    3. | All lines should be combined to a group using Object/Group.
    4. | Group now be converted using Object/Convert_to_polygon. The new Polygon is still selected; if not, select it to edit properties.
    5. | Polygon properties can now be edited, eg. addition of text, fill color, etc.

Convert to metafile
  • Windows® metafiles are graphics files, but have a different structure from most other formats. Essentially they consist of a collection of commands (in Graphics Device Interface language) to present a graphics image. Diagram Designer can convert objects to Windows® metafiles using this command. The simple procedure is
    • select an object or objects to convert
    • use the Object/Convert_to_metafile option

    The object is converted to a single metafile, which has a reduced set of properties. Be aware that metafile objects (like polygons) cannot be undone back to Diagram Designer objects. Many object properties (eg. Edit text) are not available once an object has been converted to a metafile. Line widths, for example are fixed after conversion and are relative to the current size; enlarging the metafile enlarges the line widths as well.

    Why convert?
    Once a metafile is converted, it is a pure graphical object and can be rotated to any angle using the Object/Rotate functions. In addition, converting an object to a metafile freezes its components relative to each other; no further modifications (other than shrink/grow/rotate) can be made. This might be an advantage in a complex diagram, although grouping objects exhibits similar (and less permanent) behaviour.

Add template
  • adds selected object to the current template palette in the template pane. Since only a single object is added to the template, only one object should be selected. If multiple objects are selected, behaviour may be unpredictable.

Show object tree
  • shows/hides the object tree pane. Once visible, the menu icon is changed to [image].


Help Menu

Diagram Designer | Help Menu

Click on an item for more information

Help Contents
  • opens the main help file (this file). This item is only present if the help file DiagramDesigner.chm is present.

Internet help page
  • opens your browser at the Meesoft Diagram Designer help page, http://meesoft.logicnet.dk/DiagramDesigner/help.htm.

Expression evaluator
  • opens the built-in Expression Evaluator, a powerful expression based calculation tool. More information is contained on a separate page.

Support Diagram Designer
  • Diagram Designer is user supported; users may contribute money, programming, documentation, translations, etc. This menu item opens an information window stating how to contribute. There is a link in the window to http://meesoft.logicnet.dk/DiagramDesigner/support.htm.

About
  • opens an information window with acknowledgement of contributors, links, etc.


Object Context Menu

Diagram Designer | Object Context Menu

The Object Context (ie. right-click) menu is available when hovering over an object in the Object Tree or in the Diagram pane. Although it does not provide any new functionality, it does provide easy access to some common tools.

Click on an item for more information

Note that some objects cannot be converted to a polygon; the item will be greyed out.


Template Context Menu

Diagram Designer | Template Context Menu

The Object Context (ie. right-click) menu is available when hovering over an object in the Object Tree or in the Diagram pane. Although it does not provide any new functionality, it does provide easy access to some common tools.

Click on an item for more information

Rounded 2
  • This item is the object's name and also (when clicked) opens the object's properties dialog. Note that it is possible to re-position template objects once they are added to a template (including the standard template); use the Left and Top properties to relocate objects.

Delete template object
  • deletes an object from the template. No confirmation prior to delete is done and Undo will not restore the object. If objects are deleted from any template, the original template can be re-loaded to restore the object(s); re-starting Diagram Designer will restore objects in the standard template.


Toolbar

Diagram Designer | Toolbar

Click on an item for more information
New DiagramOpenOpen recentSaveCutCopyPasteUndo (operation)Redo (operation)Zoom (set)Zoom (center)Move canvasEditDraw lineDraw arrowDraw connectorDraw curveInsert textDraw rectangleDraw ellipseLine widthCorner radiusLine colorFill colorText color

The built-in toolbar provides quick access to useful modes, tools and objects.

New Diagram

  • opens a new diagram using a standard Windows® dialog. Dialog prompts to save any existing diagram, if necessary. Opens the Page Properties dialog to allow setup for a new page (size, etc.).

Open

  • opens a standard Windows® dialog for selecting an existing diagram (.DDD) file.

Open recent

  • opens a dialog to easily select (open) one of the last 5 (maximum) diagram files.

Save

  • opens a standard Windows® dialog to save the existing diagram file (if not previously saved), or just re-saves the existing file (if already saved/named).

Cut

  • cuts the selected object(s) to the clipboard - objects are removed from the diagram.

Copy

  • copies the selected object(s) to the clipboard.

Paste

  • pastes the clipboard contents (object or objects) to the diagram. Objects are pasted near the original (if copied or cut from the diagram) and may be moved to another position. Diagram Designer can also paste text or images copied to the clipboard by other applications; images are inserted as bitmaps regardless of their original format. Such objects are pasted near the current top of the Diagram pane.

Undo (operation)

  • undo last operation (eg. cut, paste, move, etc.). Objects affected by the last operation are restored to their previous state. The number of undo operations available (ie. Undo history size) is set in the Options dialog (ie. File/Options).

Redo (operation)

  • redo the last undo. If undo was used, this operation restores the objects to their state before the undo was executed.

Zoom (set)

  • allows the user to set a fixed zoom value from the combo box (eg. 25%, 50%, 75%, 100%, 150%, 200%, 400%, 800%) or enter an arbitrary zoom by typing in the box (with or without the % sign). The placement of the diagram in the Diagram pane after the zoom is somewhat arbitrary - it is governed by the left and top margins (ie. gap between the diagram page) and the pane edge.

Zoom (center)

  • selecting this tool allows the user to zoom incrementally (factors of 2) up to 1600% by clicking the mouse. The left button increases the zoom factor (eg. 100% to 200%), centering the zoom on the magnifying glass cursor. Using the right mouse button decreases the zoom (eg. 200% to 100%) in a similar manner. The + (plus) and - (minus) keys are shortcuts for zoom center; zoom is centered on the mouse cursor. Using the + or - keys does not change the current mode (edit mode is retained, etc.).
    When this mode is invoked, the corresponding toolbar button is highlighted, like [image].

Move canvas

  • this tool allows the user to grab the canvas (ie. diagram) and drag it to a different position. This amounts to a diagram pan.
    When this mode is invoked, the corresponding toolbar button is highlighted, like [image].

Edit

  • selecting this mode cancels the Move canvas or Zoom (center) mode, if either is in effect, and returns to normal editing mode. In this mode, objects can be selected, moved, edited, etc.
    When this mode is invoked, the corresponding toolbar button is highlighted, like [image].

Draw line

  • initiates a line draw operation. After selecting this tool, left click once (and hold) on the diagram to place the first endpoint (snaps to a grid point) then drag the mouse and release the left button to place the second endpoint. The line may be manipulated or edited after drawing. If the right mouse button is pressed during the operation (while still holding the left mouse button down), a new line segment is started. Line segments drawn in this way are linked (but not grouped) together.
    Draw line mode is indicated by the greyed button, like [image].

Draw arrow

  • initiates an arrow draw operation. After selecting this tool, left click once (and hold) on the diagram to place the first endpoint (snaps to a grid point) then drag the mouse and release the left button to place the second endpoint; the arrowhead is placed automatically on the second endpoint. The arrow may be manipulated or edited after drawing. If the right mouse button is pressed during the operation (while still holding the left mouse button down), a new line segment is started. Line segments drawn in this way are linked (but not grouped) together.
    Draw arrow mode is indicated by the greyed button, like [image].

Draw connector

  • initiates an connector draw operation. A connector is similar to an arrow, except it contains a built-in crook (direction change). After selecting this tool, left click once (and hold) on the diagram to place the first endpoint (snaps to a grid point) then drag the mouse and release the left button to place the second endpoint; the arrowhead is placed automatically on the second endpoint. The connector may be manipulated or edited after drawing. If the right mouse button is pressed during the operation (while still holding the left mouse button down), a new line segment is started. Line segments drawn in this way are linked (but not grouped) together.
    Draw connector mode is indicated by the greyed button, like [image].

Draw curve

  • initiates a curve draw operation. Drawing a curve is similar to drawing a line; the first left click (and hold) initiates the operation, releasing the left mouse button terminates the curve draw. Using a right click during the curve draw adds a node to the curve, through which the final curve will pass. Curve shape is dependant on these nodes, but also on the tangential direction portions of the curve on either side of the node. The final curve appears to be derived from a second order (parabolic?) equation; curve portions do not have a single center point.
    Draw curve mode is indicated by the greyed button, like [image].

Insert text

abc

  • Adds a piece of text in your diagram. The editing box automatically appears after placing it. This can be useful to insert editable text in grouped items or metafiles. Insert text mode is indicated by the greyed button, like abc .

Draw rectangle

  • initiates a rectangle draw operation. Clicking (and holding) the left mouse button positions the upper-left corner of a filled rectangle (initially filled with white); releasing the left mouse button positions the lower-right corner of the rectangle.
    Draw rectangle mode is indicated by the greyed button, like [image].

Draw ellipse

  • initiates an ellipse draw operation. Clicking (and holding) the left mouse button positions the upper-left corner of a bounding box for the ellipse; releasing the left mouse button positions the lower-right corner of the bounding box. The bounding box is an imaginary box which "exactly" contains the final ellipse; the ellipse extremities touch the edges of the box. The final ellipse is a filled shape (initially filled with white).
    Draw ellipse mode is indicated by the greyed button, like [image].

Line width

  • opens a dialog to set line width. This dialog can exhibit 2 distinct behaviours:

    1. If objects are currently selected, the line width entered is applied only to those objects. The default width in the dialog is the line width of one of the objects selected. The default line width (for future objects) returns to its previous value after changing the line width for any pre-selected objects.

    2. If no objects are currently selected, the line width entered becomes the default line width for objects subsequently drawn.

    Line width is shown in 1/4 point increments; entering 12 for line width results in a 3 point width. One point = 1/72 inch, or approximately 1/3 millimeters. For reference, the following table may help in determining actual line width (in final printed copy):

1/4 pts

mm

inches

The line width icon changes to reflect the current default line width (approximate only).

2

0.7

0.02

4

1.4

0.05

6

2.1

0.08

8

2.8

0.11

10

3.5

0.14

Corner radius

  • Lets the user use curves instead of corners in connectors and rectangles. The corner radius icon changes to reflect the current default corner radius. This dialog can exhibit 2 distinct behaviours:

      If connectors are currently selected, the corner radius entered is applied only to those connectors. The default corner radius in the dialog is the corner radius of one of the connectors selected. The default corner radius (for future objects) returns to its previous value after changing the corner radius for any pre-selected connectors.

      If no connectors are currently selected, the corner radius entered becomes the default corner radius for connectors subsequently drawn. This is not valid for rectangles.

Line color

  • opens a standard Windows® dialog to set line color. This dialog can exhibit 2 distinct behaviours:

    1. If objects are currently selected, the line color entered is applied only to those objects. The default color in the dialog is the line color of one of the objects selected. The default line color (for future objects) returns to its previous value after changing the line color for any pre-selected objects.

    2. If no objects are currently selected, the line color entered becomes the default line color for objects subsequently drawn.

    The line color icon changes to reflect the current default line color.

Fill color

  • opens a standard Windows® dialog to set object fill color. This dialog can exhibit 2 distinct behaviours:

    1. If objects are currently selected, the fill color entered is applied only to those objects. The default color in the dialog is the fill color of one of the objects selected. The default fill color (for future objects) returns to its previous value after changing the fill color for any pre-selected objects.

    2. If no objects are currently selected, the fill color entered becomes the default fill color for objects subsequently drawn.

    The fill color icon changes to reflect the current default fill color.

Text color

  • opens a standard Windows® dialog to set object text color. This dialog can exhibit 2 distinct behaviours:

    1. If objects are currently selected, the text color entered is applied only to those objects. The default color in the dialog is the text color of one of the objects selected. The default text color (for future objects) returns to its previous value after changing the text color for any pre-selected objects.

    2. If no objects are currently selected, the text color entered becomes the default text color for text in objects subsequently drawn.

    The text color icon changes to reflect the current default text color.


Using Layers

Diagram Designer | Using Layers

The concept of Layers

The use of layers is valuable to efficient use of Diagram Designer. There are 4 layers available in the program:

  • Layer 1,
  • Layer 2,
  • Layer 3 and
  • Global stencil

The easiest way to understand the use of layers is to imagine 3 transparent sheets (layers 1, 2 and 3) laid over top of an opaque sheet (Global stencil) in order, as shown in the picture to the right.

Looking at the sheets from above, the Global stencil is visible through Layer 1, for example. But since we are looking down, layers 2 and 3 are not visible; our point of view is from the level between layers 1 and 2. Note that the Global stencil layer is visible on all pages as well as on all layers..

When working on an individual layer (eg. layer 1), the other layers, while perhaps visible, are locked; objects on those layers cannot be moved or modified. This feature makes editing diagrams easier, providing layers are used effectively.

Objects may be moved from one layer to another by

  • enable the proper layer (on which the objects currently reside) using the Diagram/Edit_layer menu,
  • selecting the object(s),
  • using cut to remove the objects, placing them on the clipboard,
  • enable the target layer,
  • paste the objects. The objects may have to be positioned, since they are pasted slightly offset.

Edit layer

The Diagram menu provides an option to select which layer is the current layer. Only the current layer can be edited.

Set layer color

Using the Diagram menu (Set layer color) changes all objects on the current layer (whether selected or not), setting their properties to the chosen color. The properties affected are

  • Line color
  • Fill color
  • Text color

Setting a new layer color may obscure text, if the fill color and text color are the same.

Setting a background color

Although no specific provision is made for setting a background color, the following procedure will accomplish this.

  1. select Global stencil as the current layer (Diagram/Edit_layer/Global_stencil).
  2. create a filled rectangle anywhere on the page, using the Draw rectangle tool.
  3. set the fill color of the rectangle to your choosing:
    • select rectangle
    • right_click/Properties
    • Style tab/Fill color
  4. set the alignment to Fill by
    • select rectangle
    • right_click/Align/Fill
  5. return to the layer you wish to work on (eg. Diagram/Edit_layer/Layer_1)

The background color of the diagram is now set to a different color, other than white (default).

Insert inherited layer (Edit menu)

Inserting an inherited layer (into the current layer) provides a means of including data in the current view, other than the data on the current layer. By inserting an inherited layer, you are actually inserting a viewport to different layer, perhaps even on a different page. This is equivalent (see layering diagram) to bonding a different layer (from any page) to the current layer; the diagram shows:

  • the current layer,
  • all layers underneath the current layer, including Global stencil and
  • the inherited layer inserted

As with normal layering, if you are editing a layer below the layer which contains the inherited layer, that inherited layer is not visible.

Note that any changes to the actual inherited layer are reflected in the inserted inherited layer; the inserted layer is not a copy, but a viewport to the actual layer.

To insert an inherited layer, select the function from the Edit menu (Edit/Insert_inherited_layer):

  1. Enter the page number. Page numbers are relative to the current page (0=current, -1=previous, 1=next). This is to allow for renaming of pages subsequent to inserting an inherited layer.
  2. Enter the layer number to insert. This must be 1, 2 or 3; the Global Stencil cannot be inserted, since it is visible on all layers anyway.


Objects

Diagram Designer | Objects

Diagram Designer implements and uses a variety of objects, each with its own set of properties (see separate page for more information). Objects are available to the user

  • on the toolbar,
  • on the standard template (loaded automatically at startup) - see diagram following,
  • through some menu items (ie. GroupObject, InheritedLayer) which convert other objects and
  • by importing into Diagram Designer (ie. BitmapObject).

Objects fall into 2 distinct categories:

Atomic: | these objects can be drawn in Diagram Designer using drawing tools, or are already part of the standard template. Creation of atomic objects is programmed internally into Diagram Designer. For AutoCad® users, think of atomic objects as simple entities.
Composite: | these objects are either imported externally, or are created from atomic objects. Composite objects are handled internally by Diagram Designer but their content is not created directly by the program. For AutoCad® users, think of composite objects as blocks.

Diagram Designer's graphics objects are:

NAME | TYPE | COMMENTS
StraightLine | Atomic | This is a straight line, as implemented both in the toolbar and on the standard template. Arrows are a subset of straight lines; only the end styles are changed.
ConnectorLine | Atomic | This object appears on the toolbar (referred to as a Connector), and on the standard template (as Connector or AxisLine). It is a collection of 3 intimately joined lines, automatically adjusting lengths and position as a single endpoint is moved. Endpoints may have a variety of styles; this is only a property and not a separate object.
CurveLine | Atomic | This object is a genuine curve, with multiple deflection points as needed. It appears only on the toolbar.
TextObject | Atomic | This object is a generic container for text only. Properties for this object are only designed to manipulate text; only the text is visible. Text objects appears on the standard template.
RectangleObject | Atomic | Rectangles are available on the toolbar and on the standard template. Rectangles are simple 4 sided figures as per the geometric definition.
EllipseObject | Atomic | Ellipse objects are available from the toolbar and on the standard template. Note that circles are only a subset of ellipses, with the horizontal and vertical axes of equal length.
GroupObject | Composite | Group objects are created from other objects, using a menu item (Object/Group or right-click context menu). Group objects can be disassembled using Ungroup, making them unique in the collection of composite objects. Group objects cannot be resized.
PolygonObject | Composite | Polygons are available on the standard template (4 sided only), but may also be created from a collection of lines. They can be edited to create new vertices (or link points). Polygons cannot be disassembled.
BitmapObject | Composite | Bitmap objects can only be created by inserting a pre-made graphics image (see Edit/Insert_picture), converted automatically to a bitmap by Diagram Designer. Once inserted, they have simple changeable properties but may only be edited using Image Analyzer, another Meesoft product, which integrates with the object's properties menu. Bitmap objects may, of course, be edited prior to insertion with any graphics editor. Bitmaps do not support transparent colors (as do GIFs, for example); importing a bitmap will eliminate any transparent qualities.
MetafileObject | Composite | This is a standard Windows® metafile object for representing graphics images. While its properties are limited, it can be rotated to any angle. Metafile objects can be imported directly (Edit/Insert_picture) or created from other objects. Metafile objects cannot be disassembled.
FlowchartObject Atomic Flowchart objects appear in the standard template, and are essentially one object. Each flowchart object has a property to change it into another flowchart object (ie. shape), as well as other simple properties. Flowchart objects can also adopt any of the following layouts:
  • Side bars
  • Rounded 1 (not shown on standard template at startup)
  • Rounded 2
  • Rounded 3 (not shown on standard template at startup)
  • Slant right
  • Slant left
  • Odd rounded 1
  • Odd rounded 2
InheritedLayer | Atomic | Inherited layers are created as an object only from a menu item - Edit/Insert_inherited_layer. Inherited layers are a type of viewport - inserted onto a layer - which accesses a view of a different layer on any page. For a more detailed discussion of inherited layers, see Using Layers.

Diagram - Standard Template | Not shown on template
 | An InheritedLayer object is not shown. Since it is merely a viewport to other objects, it does not represent itself as different from conventional objects.


Object Properties

Diagram Designer | Object Properties

All Diagram Designer objects - except InheritedLayer objects - have user editable properties. Some properties are common to most or all objects while some are particular to a specific object type. Object properties are available by selecting an object, then using the right-click context menu. The properties dialog can also be accessed by double-clicking the object in the Object Tree.

Following are descriptions of object properties for each object type.

Object name | Common name | Comments
StraightLine | Line | see Line Properties
ConnectorLine | Connector, AxisLine | See Connector Properties
CurveLine | Curve | See Curve Properties
TextObject | Text | See Text Properties
RectangleObject | Rectangle | See Rectangle Properties
EllipseObject | Ellipse | See Ellipse Properties
GroupObject | Group | See Group Properties
PolygonObject | Polygon | See Polygon Properties
BitmapObject | Bitmap | See Bitmap Properties
MetafileObject | Metafile | See Metafile Properties
FlowchartObject Flowchart Object 8 sub-categories exist for this object:
  • Side bars
  • Rounded 1
  • Rounded 2
  • Rounded 3
  • Slant right
  • Slant left
  • Odd rounded 1
  • Odd rounded 2

See Flowchart Object Properties

InheritedLayer | Inherited Layer | Shown in Object Tree as (eg.) Page p Layer 3. See Inherited Layer Properties


Line Properties

Diagram Designer | Line Properties
 | (StraightLine object)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property Value Comments
Name: text Each object can have a unique name. Names show up in the Object Tree pane.
Text: text See Text Properties
Horizontal text alignment: - Block left
- Center
- Block right 		The items are use to align text horizontally.
Alignment | Example | Comments
Block left |  | Longest line is centered, other lines aligned with left edge of that text.
Center |  | All lines are centered horizontally in the text box.
Block right |  | Longest line is centered, other lines aligned with right edge of that text.

Property Value Comments
Line width: number Width of line shown is always in 1/4 point (ie. 1 point = 1/72") increments.
Line start: See →
None Assigns a shape to the start of the line, as shown in the table to the left. Shape may also have an assigned size (number = 1..?); set size by experimentation.
Arrow 1
Arrow 2
Arrow 3
Double arrow
Stop
Circle
Ball
Line end: See → Identical to Line start, but operates on end of line.
Line style: See →
Solid Line styles are selected by image in a list box. All lines in an object will adopt the selected style.
Line color: See → Color is chosen from a standard Windows® color dialog. All lines in an object will adopt the selected color. The [image] button will clear the color, rendering the line(s) transparent.
Text color: See → Color is chosen from a standard Windows® color dialog. Any text placed in the object (other than Name:) will adopt the selected color.


Connector Properties

Diagram Designer | Connector Properties
 | (ConnectorLine object)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | - Block left - Center - Block right | See Line Properties

Property | Value | Comments
Line width: | number | See Line Properties
Line start: | See → | See Line Properties
Line end: | See → | See Line Properties
Line style: | See → | See Line Properties
Line color: | See → | See Line Properties
Text color: | See → | See Line Properties


Curve Properties

Diagram Designer | Curve Properties
 | (CurveLine object)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | - Block left - Center - Block right | See Line Properties

Property | Value | Comments
Line width: | number | See Line Properties
Line color: | See → | See Line Properties
Text color: | See → | See Line Properties


Text Properties

Diagram Designer | Text Properties
 | (TextObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property Value Comments
Name: text See Line Properties
Text: text Text entered here is displayed at the middle of the line (or in the center of other objects). All text formatting parameters available may be used, if desired. It may be more convenient to double click on the object to open the Edit text dialog - parameters are displayed there for reference.
Horizontal text alignment: See → The items are use to align text (relative to the containing box) horizontally. In the examples below, the text margin is set to 24.
Alignment | Example | Comments
Left |  | All lines are aligned to the left margin.
Center |  | All lines are centered horizontally in the text box.
Right |  | All lines are aligned to the right margin.
Block left |  | Longest line is centered, other lines aligned with left edge of that text.
Block right |  | Longest line is centered, other lines aligned with right edge of that text.
Vertical text alignment: See → The items are use to align text (relative to the containing box) horizontally. In the examples below, the text margin is set to 24; horizontal text alignment is center.
Alignment | Example | Comments
Top |  | All lines are aligned to the top margin.
Center |  | All lines are centered vertically in the text box.
Bottom |  | All lines are aligned to the right margin.
Text margin: number Measured in 1/4 points (1 point = 1/72 inch), this value controls the space between the edge of text and the edge of the text box (ie. container). This value is only applicable to
  • Horizontal text alignment: left, right
  • Vertical text alignment: top, bottom.

Using other alignments, this value has no effect. The examples show horizontal margins; vertical margins are affected in a similar manner.

Example:
Left: number Sets the location of the the text box, relative to the left edge of the page (0 = @ left edge). Number is in current units, as set in the Options dialog.
Top: number Sets the location of the the text box, relative to the top edge of the page (0 = @ top edge). Number is in current units, as set in the Options dialog.
Width: number Sets the width of the the text box. Number is in current units, as set in the Options dialog. Note that the text will still be visible even if the box is too small to contain it.
Height: number Sets the height of the the text box. Number is in current units, as set in the Options dialog. Note that the text will still be visible even if the box is too small to contain it.

Property | Value | Comments
Text color: | See → | See Line Properties


Rectangle Properties

Diagram Designer | Rectangle Properties
 | (RectangleObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | See → | See Text Properties
Vertical text alignment: | See → | See Text Properties
Text margin: | number | See Text Properties
Left: | number | See Text Properties
Top: | number | See Text Properties
Width: | number | See Text Properties.
Height: | number | See Text Properties

Property | Value | Comments
Line width: | number | See Line Properties
Line color: | See → | See Line Properties
Fill color: | See → | Color is chosen from a standard Windows® color dialog. The body an object will adopt the selected color, ie. the object is filled with the color. The [image] button will clear the color, rendering the object body transparent. You can play with fill colors using the Color Test tool.
Text color: | See → | See Line Properties


Ellipse Properties

Diagram Designer | Ellipse Properties
 | (EllipseObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | See → | See Text Properties
Left: | number | See Text Properties
Top: | number | See Text Properties
Width: | number | See Text Properties
Height: | number | See Text Properties

Property | Value | Comments
Line width: | number | See Line Properties
Line color: | See → | See Line Properties
Fill color: | See → | See Rectangle Properties
Text color: | See → | See Line Properties


Group Properties

Diagram Designer | Group Properties
 | (GroupObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property Value Comments
Name: text See Line Properties
N link points defined: See → Shows the current number of link points for this object prior to entering the editor. Pressing the [image] button will enter the link point editor, while pressing [image] will clear (ie. delete) all current link points.

The link point editor allows the user to assign, edit or delete link points. A group object has no native link points; link points of the original objects are masked when the group object is created. All link points entered are relative to the current bounding box - see below. Once entered, link points will show on the object and can be used to link to other objects.

Link points for group objects may be added in any order, while adding links points for a polygon object must be done in the order of polygon vertices. The link point editor has no provision for reordering link points; link points must be entered in order.

Group objects without link points still obey the snap grid; the bounding box is aligned with the snap grid.

Link positions: See → If the [image] box is checked, link points defined for this group object are adjusted for line width. Link points on the outside perimeter of the bounding box are moved to the center of any perimeter lines, rather than the outside edge of the line; the bounding box is adjusted accordingly. Note that objects linked to the current link points of a group object will be affected when Inner bounds is enabled. Also note that the location of link points is always relative the bounding box; enabling Inner bounds will adjust the positions of all link points accordingly.

Property | Value | Comments
 |  | Group objects have no editable Style properties.


Polygon Properties

Diagram Designer | Polygon Properties
 | (PolygonObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | See → | See Text Properties
Left: | number | See Text Properties
Top: | number | See Text Properties
Width: | number | See Text Properties
Height: | number | See Text Properties
N link points defined: | See → | See Group Properties

Property | Value | Comments
Line width: | number | See Line Properties
Line color: | See → | See Line Properties
Fill color: | See → | See Rectangle Properties
Text color: | See → | See Line Properties


Bitmap Properties

Diagram Designer | Bitmap Properties
 | (BitmapObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property Value Comments
Name: text See Line Properties
Left: number See Text Properties
Top: number See Text Properties
Width: number See Text Properties
Height: number See Text Properties
Bitmap: See → Two options are available here:
Clicking the Edit button invokes Meesoft Image Analyzer to edit the bitmap. No further instructions on using Image Analyzer are provided in this document.
Exports the bitmap to another file or format. 10 different formats are available; 12 if Image Analyzer is installed.
N link points defined: See → See Group Properties

Property | Value | Comments
Bitmap scaling: | See → | If the Halftone box is checked, the bitmap is displayed using halftones, a method predominately used in displaying monochrome images. Try this display method to see if image quality is improved.


Metafile Properties

Diagram Designer | Metafile Properties
 | (MetafileObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Left: | number | See Text Properties
Top: | number | See Text Properties
Width: | number | See Text Properties
Height: | number | See Text Properties
Rotation angle: | number | A rotation angle (degrees) may be selected using the spinner control, but any angle may be entered in the spinner box. As per the rotation item in the Object menu, angles are in degrees and are measured counter-clockwise (ie. mathematical convention).
Metafile: | See → | Only a single option is available; [image] allows exportation of the metafile image as either a Windows® metafile (.wmf - 16 bit) or an Enhanced metafile (.emf - 32 bit) image. Note that if an object is already an EMF (32 bit) metafile, and is exported to a WMF (16 bit), it is possible that some aspects of the metafile may be lost; 32 bit metafiles support an enriched format while 16 bit metafiles do not.
N link points defined: | See → | See Group Properties

Property | Value | Comments
 |  | Metafile objects have no editable Style properties.


Flowchart Object Properties

Diagram Designer | Flowchart Object Properties
 | (FlowchartObject)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page.

Property | Value | Comments
Name: | text | See Line Properties
Text: | text | See Text Properties
Horizontal text alignment: | See → | See Text Properties
Vertical text alignment: | See → | See Text Properties
Text margin: | number | See Text Properties
Left: | number | See Text Properties
Top: | number | See Text Properties
Width: | number | See Text Properties.
Height: | number | See Text Properties

Property Value Comments
Line width: number See Line Properties
Line color: See → See Line Properties
Fill color: See → See Rectangle Properties
Text color: See → See Line Properties
Layout: See → Flowchart objects can adopt any of the following layouts; each layout presents a different appearance to the generic flowchart object.
  • Side bars
  • Rounded 1 (not shown on standard template at startup)
  • Rounded 2
  • Rounded 3 (not shown on standard template at startup)
  • Slant right
  • Slant left
  • Odd rounded 1
  • Odd rounded 2

The standard template presents some of the possible layouts - see Objects for representations of all possible layouts.


Inherited Layer Properties

Diagram Designer | Inherited Layer Properties
 | (InheritedLayer)

Values shown in the table are simply types of values to be entered for a given property. Some common properties may be linked to a single description on this or another page. Although inherited layers have object properties, there is usually no need to alter the default properties.

Accessing Inherited Layer Properties

Inherited layers cannot be selected from the Diagram pane. Selecting an inherited layer object from the Object Tree will allow the user to either:

  • use the right-click context menu on the object (in the Diagram pane)
  • double-click on the object in the Object Tree pane to directly access Properties
Property | Value | Comments
Name: | text | See Line Properties
Left: | number | See Text Properties. Default Left value is 0; inherited layer is places at the left edge of the page.
Top: | number | See Text Properties. Default Left value is 0; inherited layer is places at the top edge of the page.
Width: | number | See Text Properties. Default Width value is the same as page width, as set in the Page Properties dialog. If desired (why?) this value may be altered. This will affect the appearance of any objects on the inherited layer.
Height: | number | See Text Properties. Default Height value is the same as page height, as set in the Page Properties dialog. If desired (why?) this value may be altered. This will affect the appearance of any objects on the inherited layer.


Selecting Objects

Diagram Designer | Selecting Objects

Before objects can be moved or edited, they must be selected (except for Template objects). Several methods of selection exist:

T he Object Tree

A single left click on a named object in the Object Tree will select it. Double-clicking an object opens its property dialog, while right-clicking on an object opens its context menu. In the context menu, properties can be accessed, as well as other features available on other menus. Only a single object can be selected from the Object Tree. Objects which are not visible (ie. empty text boxes) can be easily selected from the Object Tree.

The Diagram Pane

Objects in the Diagram Pane may be selected by

  • a single left-click
  • holding the left mouse button down, while not over an object, then dragging the mouse to create a selection box. Any objects partially enclosed by the selection box will be selected (ie. multiple objects).

Either of the above methods may be further augmented by holding the Shift key down while selecting, allowing multiple objects or multiple selection boxes to be used, regardless of whether the objects are neighbours or not.

The Template Pane (Palette)

Objects in the current template cannot be selected, but can be edited (individually) by using the double-clicking the object from the Template pane; the object's properties dialog will open. In addition, each object has a right-click context menu.

Using Multiple Objects

Multiple objects may be

  • moved in unison
  • copied
  • cut
  • deleted
  • edited. Only certain properties which are common to all selected objects may be edited en masse (ie. all at once), such as
    • text - providing the small edit box in object properties is used, not the text editing dialog
    • line width
    • line color
    • fill color
    • text color
    • text alignments - providing all objects selected have the alignment to be edited

    Other properties can be determined by experiment; some other properties can be edited on multiple objects, depending on which objects are selected.

Deselecting Objects

A single left-click on an empty portion of the diagram (ie. no objects) will deselect all objects. Objects may be re-selected by any method following deselection. Deselection is only necessary when

  • multiple objects are selected
  • it is desired to select a single object of the ones already selected.


Linking Objects

Diagram Designer | Resizing and Moving Objects

Resizing

When individual objects are selected, key control points (ie. end points of lines, perimeter link points, bounding box corners, etc.) are active for resizing or adjusting the object. Grabbing these points - hold left mouse button - and dragging them in any direction will resize the object (in the case of a shaped object - rectangle, ellipse, etc.) or move the endpoint (in the case of a line or connector). Prior to grabbing the control point, the mouse cursor will indicate the movement direction.

Grab control point | Stretch ellipse

Note that the following keys have an effect on resizing operations:

  • Alt - temporarily disables the grid snap feature. Movement is independent of grid.
  • Ctrl - square or orthogonal movement mode. Movement is equal in the X and Y directions; this will create circles out of ellipses, squares out of rectangles, etc. If the endpoints of lines or connectors are moved, movement is only in the cardinal directions (up/down, left, right).

Moving

Moving objects is only possible when the cursor is shown as [image]; this cursor can be obtained by placing the cursor in the middle of the object after selecting it. Holding the left mouse button down allows the object to be dragged to a new location. If multiple objects have been selected, all objects are moved when the cursor is shown as preceding. Note that the following keys have an effect on moving operations:

  • Alt - temporarily disables the grid snap feature. Movement is independent of grid.


Linking Objects

Diagram Designer | Linking Objects

One of the features of Diagram Designer is object linking. Most objects have link points (the little red Xs), either built-in or user defined, which allow linking of lines and connectors. Once a line (or connector) is linked to an object, moving that object also moves or re-calculates the line or connector. An example of this:

  1. Polygon and Odd Rounded 2 object are linked together by a connector.
  2. Polygon is moved to the right, connector adjusts.

Linking lines and connectors to objects can be a little tricky; basically, the procedure is as follows:

  1. draw the (non-line, non-connector) objects required
  2. initiate a connector draw operation
  3. place the first point of the connector on a link point of the polygon. Make sure the green box is present, signifying that the connector start is exactly on the link point, and that a link will be created. If the green box is not present, no link will be made.
  4. drag the other end of the connector to the Odd Rounded 2 object link point. Make sure the green box is showing as well. If the mouse is directly over the link point, the green box should appear.
  5. release the mouse button. The connector should be linked to the objects.

If a line or connector is linked to objects, selecting that line should cause the green boxes to appear. If they do not appear, the endpoints of the line or connector must be moved to a location directly over the link point - some magnification may help in this operation.

1. Normal view (100%) | 2. Zoom 1600% | 3. Select connector | 4. Move endpoint to link point. Link is created.

Using the Connect links tool (Diagram menu) will force link connections also, but only for those lines and connectors whose endpoints lie exactly (ie. within the internal accuracy of Diagram Designer) over a link point.


Editing Text

Diagram Designer | Editing Text

All Diagram Designer objects (except Group, Bitmap, Metafile and Inherited Layer) accept text for display in the Diagram pane, inside the body of that object. To enter text, you may edit the Text: property in the object's properties or double-click the object in the Diagram pane. Double-clicking opens the text editing dialog, with some editing code reminders - this is preferred. The following editing codes (with examples) may be used in any text entered.

Formatting Codes

Effect | Code(s) | Source Example | Output example | Comments
Bold | \B \b | Why \Bme\b? | Why me? | turn off with \b
Underline | \U \u | Why \Ume\u? | Why me? | turn off with \u
Superscript | \H \h | E=mc\H2\h | E=mc2 | turn off with \h
Overline | \O \o | \Oaaaaaa\o | āāāāāā | turn off with \o
Subscript | \L \l | Footnote\L2\l | Footnote2 | turn off with \l
Italic | \I \i | Why \Ime\i? | Why me? | turn off with \i
Font | \"fontname" | Why \"lucida handwriting"me? | Why me? | font name must be in double quotes
Font size | \### | Why \014me? | Why me? | requires 3 decimal digits
Symbol font | \S \s | see Using Symbol Font |  | \S = enable Symbol font \s = restore diagram font
Text color | \Chhhhhh | Normal\Cff0000Red | NormalRed | hhhhhh stands for 6 hex digits, corresponding to RRGGBB (red/green/blue), as used in web page design, etc. You can play with colors here to see the effect.
link | \Afilename | \Atest.ddd | n/a | creates a link to another diagram, a path (absolute or relative) to another file, a mailto: link or a URL. Double clicking on the object will activate the link and load (example) TEST.DDD. The link text is not visible; loading the new diagram opens a new copy of Diagram Designer.

Special Symbols

Diagram Designer's text editing can insert special symbols using backslash notation. Following is a list of special symbols available:

Code(s) | Symbol (eg.) | Comments (Arial Character Name)
\+ | ± | Plus-Minus Sign
\- | ÷ | Division Sign
\* | × | Multiplication Sign
\\ | \ | Reverse Solidus (backslash)
\p | 1 | displays number of current page
\c | 9 | displays total number of pages
\P | Page 1 | displays current page title
\n |  | starts new line, equivalent to Enter
\. | · | Middle Dot
\o | • | Bullet
\# | ♦ | Black Diamond Suit
\' | ° | Degree Sign
\= | ≠ | Not Equal To
\~ | ≈ | Almost Equal To
\< | ≤ | Less-Than Or Equal To
\> | ≥ | Greater-Than Or Equal To

Using Symbol Font

When entering text for display, the Symbol font can be enabled easily using the \S and \s terminators; actual text should be placed between the two codes. Ordinary text entered will then be displayed in the Symbol font. Non-keyboard characters (default font) can be entered by

  • hold <Alt> key down

  • enter ASCII character number (only critical digits!)

  • release <Alt> key

This method can be used for either default characters unavailable on the keyboard, or for Symbol characters: eg. \S¶\s = ¶ using character 20 in the Arial default font.

Below you will find a character matrix, showing the default font characters, as well as the same character interpreted using the Symbol font (e.g. M \SM\s). Click on the image for a full-size copy of the image. The image was created in Diagram Designer; the diagram file may be downloaded here (note: Layer 1 and Layer 2 were used in the diagram). Note that using Diagram Designer to enter characters (using the <Alt> method) may yield results for a given character number different from using the Windows® Character Map utility, or using another program to create the characters and paste them into Diagram Designer objects. Characters that are blank (except character 32=0x20, space character) or that have ? as the displayed character, are unavailable using the <Alt> method of entering characters.

Insert/Overwrite

When the Edit Text dialog is initially invoked, insert mode is active; characters typed are inserted at the cursor. Pressing the Insert key toggles between insert and overwrite (characters are overwritten) mode. No indicator is shown to determine which mode is active; when typing the mode will be obvious. This behaviour is not present when editing text from the Properties dialog (i.e. Text: property); insert mode is continuously active.


Diagram Designer | Color Test

Instructions

  • adjust the red, green or blue to see the effect. Small arrows increment/decrement by 1, large arrows use 16.
  • Reset button will reset control to default (at entry).
  • controls may be a bit sluggish - click slowly.
  • get a quick color setting using the color grid (select Text or Fill)
Text
Fill

Text
Fill


Expression Evaluator

Diagram Designer | Expression Evaluator

The Diagram Designer Expression Evaluator is a powerful programmable calculator and equation plotter. Notable features are:

  • trigonometric functions
  • hyperbolic functions
  • logical operators
  • named user variables can be created and used
  • recursive descent parsing (ie. handles nested terms)
  • equations can be programmed and used later
  • multi-line programming with a single result
  • some constants built-in, more can be added by user using expressions
  • equation solving (roots, minimums, etc.) and plotting - plots can be inserted into diagrams

USAGE

The Expression Evaluator is used by entering statements in the expression area, then using Evaluate (F5) to evaluate the statements. Statements fall into the general format of:

  1. :Variable_name=variable_contents;
  2. :Function_name(function_variable)=expression_in_variable;
  3. expression_to_evaluate

Variable assignments and user functions (enclosed by : and ;) may used multiple times (in any order), but the expression to evaluate is a single expression and is the last line of the program. Note that variable names, function names (internal and external) and internal constants are case-sensitive; UserFunc is not the same as userfunc. Spaces in expressions and assignments should not be used, if possible. Note that the Expression Evaluator does not support the use of

  • strings; it is numeric only
  • comments. You may comment your code, but when using it (ie. pasting it into Expression Evaluator), comments must not be used.

After the program (ie. statements and expressions) is entered, pressing F5 (or clicking the button) will evaluate all statements (in order) and place the result in the results area in decimal, hexadecimal and binary format. Results can be highlighted and copied to the clipboard, if desired. Also expressions may be pasted into the expression area to save typing.

EXAMPLE

Problem

The formula Y=X2 determines a parabola, centered around the Y axis (ie. X=0). Imagine that 2 dimensional liquid is poured into the parabolic cup; find the cross-sectional area of that liquid, with the cup filled to a level of 2.
Solution Area under the curve is calculated by integrating the function, with respect to X (ie. ∫ƒ(x) dx, where ƒ(x) = x2), yielding 1/3*X3. If liquid were to be poured into the parabolic cup formed by the equation, the cross sectional area of that liquid (2 dimensional) can be calculated using the area under the parabola, for the limits of X, and the area of a simple rectangle. First, the value of N must be calculated - the point on the X axis where the level of 2 units occurs. Since Y=N2 and Y = 2, then N = sqrt(2). This can be proven by using an "adjusted" equation Y=X2 - 2 which shifts the parabola down 2 units. This means that the value of X which yields a Y of 0 (the fill point) is equal to N. The proof of this can be input into Expression Evaluator as:

num.root(X^2-2,X)=sqrt(2)

This means: if the equation root = √2 then return true (ie. 1) as the result, else return 0 (false). Pasting this into the expression area and evaluating confirms this result. The simple rectangle area (includes the desired area, plus the area under the curve) = (√2 - (-√2 ) ) * 2. Reducing this further; this can be written as:

(sqrt(2)+sqrt(2)) * 2

The area under the curve (from -N to N), then can be calculated (with a little reducing) as:

:N=sqrt(2);
:A_under=(2*N^3)/3;

Subtract this from the rectangle, then yields the final program as:

:N=sqrt(2);
:A_under=(2*N^3)/3;
:A_rect=(sqrt(2)+sqrt(2))*2;
:A_in=A_rect-A_under;
A_in

Evaluating this program yields a final result of 3.771236166328, the area of the liquid.

REFERENCE

OPERATORS Operators are listed in order of precedence. Note: symbol spelling is case sensitive

Equation solving, etc. | RESULT/Comments
& | logical AND. For testing purposes, any non-zero number is considered true.
| | logical OR
= | equality (test). Tests return 0 (false) or 1 (true)
# | inequality (test)
> | greater than (test)
< | less than (test)
+ | addition
- | subtraction, or negation (as in -5)
* | multiplication
/ | division
% | modulus. Result is the remainder of integer division, eg. 16.1%3.03 is equivalent to 16/3. Remainder (result) in this example is 1.
^ | power (ie. Y^X = YX). Raises any real (ie. Y) to the power of any other real (X).

CONSTANTS Note: symbol spelling is case sensitive

CONSTANT | RETURNS/Comments
e | 2.718281828459
inf | infinity (≈ 1 / 0)
kb | kilobyte = 1024
Mb | megabyte = 1048576
pi | = 3.14159265359

FUNCTIONS Note: symbol spelling is case sensitive

FUNCTION - trigonometric | RETURNS/Comments
cos(x) | cosine of X (in radians)
arccos(x) | inverse cosine of X, returns radians
sin(x) | sine of X (in radians)
arcsin(x) | inverse sine of X, returns radians
tan(x) | tangent of X (in radians) = sin(x) / cos(x)
arctan(x) | inverse tangent of X, returns radians
cot(x) | cotangent of X (in radians) = cos(x) / sin(x)
FUNCTION - hyperbolic | RETURNS/Comments
cosh(x) | hyperbolic cosine = (ex + e-x) / 2
arccosh(x) | inverse hyperbolic cosine of X
sinh(x) | hyperbolic sine = (ex - e-x) / 2
arcsinh(x) | inverse hyperbolic sine of X
tanh | hyperbolic tangent of X = sinh(x) / cosh(x)
arctanh(x) | inverse hyperbolic tangent of X
FUNCTION - rounding | RETURNS/Comments
ceil(x) | nearest integer, rounding up towards positive infinity
floor(x) | nearest integer, rounding down towards negative infinity
frac(x) | fractional part of real number
round(x) | nearest integer, up or down
FUNCTION - random no. | RETURNS/Comments
rand(x) | real number in range 0..X This is a white noise random number generator. No apparent pattern of the random numbers should be detected.
randn(x) | return Gaussian random numbers, with X as a standard deviation. Gaussian random numbers are clustered around 0 in the typical Gaussian standard distribution curve. This function returns random numbers clustered around 0, with a standard deviation of X.
FUNCTION - logarithmic | RETURNS/Comments
exp(x) | natural exponential function = ex
ln(x) | natural logarithm (base e)
log10(x) | common logarithm (base 10)
log2(x) | logarithm (base 2) where x = 2log2(x)
FUNCTION - misc | RETURNS/Comments
abs(x) | absolute value of X (value or variable)
bin(x) | converts X (binary integer) to decimal
fac(x) | factorial function, eg. fac(4) = 4 * 3 * 2 * 1 = 24
sqrt(x) | square root of X

EQUATION SOLVING, ETC. Note: symbol spelling is case sensitive

FUNCTION | RETURNS/Comments
num.Guess | Expression Evaluator uses numeric methods to solve for minimums, etc. This variable houses the initial guess used in numeric computations (initial default on program startup = 0.500000001).
num.argmin(expression,x) Find X that minimizes the expression given.
Example: num.argmin((x-1)*(x-1)+4,x) will yield 0.999999999976 as a result. The equation is a parabola, centered on the X=1 axis and shifted 4 units up. The result is effectively 1.0(internal rounding errors will cause the last few decimal places to change), the value of X at the minima of the curve.
num.min(expression,x) Find the minimum value for the expression show. This is similar to num.argmin, but returns the function of X (or other variable) at the minima.
Example: num.min((x-1)*(x-1)+4,x) will yield 4 as a result, the value of ƒ(x) at the minima.
num.root(expression,x) Find the root (value of X where ƒ(x)=0) of the expression.
Example: num.root(x^2-5*x+4,x) yields 1.0 as a result.
This is verified by showing that 12 - 5 * 1 + 4 = 0. In fact, there is another root at 4.0; this can be found by setting num.Guess to 6 prior to computation. This can be accomplished by the following program:

:num.Guess=6;
num.root(x^2-5*x+4,x)

which yields 4 as the result.

num.solve(equation,x) Solves for the value of the target variable. This is similar to num.root, but solves for X (or other variable) yielding values other than 0.
Example: num.solve(y^2-5*y+4=14,y) yields 6.531128874149 as a result. This can be proved by pasting the following into Expression Evaluator and evaluating:

:y=6.531128874149;
y^2-5*y+4

The result (13.999999999998) is effectively 14, with rounding errors, proving the equation's solution.

PLOTTING Note: symbol spelling is case sensitive

Equation solving, etc. RETURNS/Comments
plot(expression,x) Plots any expression, if possible. Try pasting this into the expression area:

plot(1/x,x)

The above plots the equation Y=1/X, including both the positive and negative portions. Once evaluated, the plot window opens displaying the plot, and allowing different X limits (range). The plot can be copied to the clipboard, then pasted into Diagram Designer as a metafile. Left-clicking on any point of the curve (as near a possible) and hovering there will display the coordinates (approximate) of that point.

In the examples above for num.argmin, etc., try pasting the samples into Expression Evaluator, but change the function to plot - you can see the answer!


Keyboard Shortcuts

Diagram Designer | Keyboard Shortcuts

Following is a list of keyboard shortcuts, as defined in Diagram Designer:

File Menu |
F3, Ctrl+O | Open
Ctrl+S | Save
F12 | Save As
Ctrl+P | Print
F4 | Slideshow
F9 | Options
Edit Menu |
Ctrl+Z | Undo
Ctrl+Y | Redo
Ctrl A | Select All
Shift+Del, Ctrl+X | Cut
Ctrl+Ins, Ctrl+C | Copy
Shift+Ins, Ctrl+V | Paste
Ctrl+B | Paste Special
Del | Delete
Diagram Menu |
Ctrl+F7 | Spell Checker
Ctrl+R | Rearrange Pages
Ctrl+L | Connect Links
Object Menu |
Alt+Enter | Object Properties
F2 | Edit Text
Ctrl+G | Group
Ctrl+U | Ungroup
Help Menu |
F1 | Help Contents (if DiagramDesigner.chm installed), About (if no help file)
F11 | Expression Evaluator
Toolbar |
F6 | Zoom Mode
F7 | Move Canvas Mode
F8 | Edit Mode
F5 | initiate Draw Line
+ | increase zoom (x2) centered on mouse cursor, see zoom center. Using the + or - keys does not change the current mode (edit mode is retained, etc.).
- | decrease zoom (x2) centered on mouse cursor, see zoom center. Using the + or - keys does not change the current mode (edit mode is retained, etc.).
Slide Show |
PageDown | Next page
PageUp | Previous page
Home | First page
End | Last page
G | Goto page
Esc | Close
Misc |
F10 | focus = Main Menu
Ctrl+1 | select Page 1 (Note: not numeric keypad!)
Ctrl+2, etc. | select Page 2, etc.
Insert | toggles between insert and overwrite mode, in Edit Text dialog


Glossary

Diagram Designer | Glossary

TERM | MEANING/comments
atomic | re: objects, an atomic object is in its simplest form, that is, it cannot be separated into components. The term atomic comes from Lisp, an early programming language.
bitmap | a simple image format, containing a rectangular array of colored pixels. Bitmaps, while used extensively in Windows®, are seldom used for final images, since they offer no compression (size reduction).
bounding box | an imaginary (although it may be visible) box which contains an object or collection of objects. The size of a bounding box is determined by the X and Y extremities of the object(s).
canvas | the term applied to the actual drawing area of a diagram, similar to the canvas of a painting
CHM | the file extension of a compiled HTML help file. CHM files exhibit most of the properties of true HTML files, but have the advantage that multiple files (such as a complete website) may be compiled to a single file.
context (menu) | a context menu is a Windows® menu, only visible when the mouse is hovered over a specific location (such as an object), then the right-mouse button is clicked. Context menus provide an easy way to access features specific to a particular object or window location.
dictionary | a spell check dictionary (for Diagram Designer) is simply a collection of words, arranged in alphabetical order for high speed searching
expression | an expression (mathematical) consists of mathematical notation which can be evaluated (usually) to a single numeric value, eg. 1 + (23 * 6) * sine (85)
flowchart | a diagram explaining (pictorially) the sequence of events in a process, program, etc.
flowchart object | the name for a class of Diagram Designer object which can be used as a symbol in a flowchart
grid | a rectangular array of points (user alterable) which provides a visual cue as to object location. See snap.
group | a collection of diagram objects, joined together to form a single object
inherited (layer) | Object inheritance (in the programming realm) means that an object is created from other objects and adopts (inherits) all the properties of those objects. An inherited layer is an object inserted into a diagram which adopts all the properties of the target layer.
layer | see Using Layers
link | an internal connection made between a line or connector and an object
link point | a point on an object (either internal or user created) to which a line or connector may be linked
MDI | Multiple Document Interface - a method used by many Windows® programs to accommodate multiple documents open in a single program
metafile | see Object_menu/Convert_to_metafile
node | in curve objects, the location of a key deflection point in a continuous curve
object | a collection of lines and arc, etc. which is bound together to form a single shape
object tree | the leftmost pane (optionally visible) showing the hierarchy of current objects in the diagram
page | each diagram can contain separate pages, in effect, a different diagram. This concept is similar to spreadsheets which can contain multiple pages in the same file.
palette | the rightmost pane in the main screen, showing the collection of template objects
pane | a portion of a window which allows separate content, much like the panes of a wood frame window
point | a old printing unit, adopted from the printing press use. One point = 1/72 inch.
preview | a view of the diagram, as it would be printed - user grid is masked, background is set to white, etc.
properties | object properties are those features which determine the quality or behaviour of the object. Object properties include: line width, line color, text size, etc.
registry | the single repository of Windows® configuration data. The registry can be edited by a user (with care!).
shortcut | a file in Windows® which allows quick and easy access to another location or file
slide show | a mode which allows full page viewing of diagram pages, providing easy movement between pages
sliders | Windows® controls which allow viewing of an window which is larger than the page
snap | feature which allows objects to be easily aligned with a user grid
stencil (global) | see Using Layers
template | a pre-made object which can be inserted into a diagram
zip (archive) | a common compression format used to collect files into a single file (a single file containing multiple compressed files)


Contacts

Diagram Designer | Contacts

Current versions of

  • Diagram Designer
  • Image Analyzer
  • templates
  • documentation, updates to same
  • Language packages
  • Spelling dictionaries

can be obtained on the Meesoft website at http://meesoft.logicnet.dk

For questions about using MeeSoft software, please use our support forum at http://meesoft.logicnet.dk/support/ .

This manual was prepared by Allen Titley, BCLS, British Columbia, Canada. Questions or comments (positive or negative!) regarding this manual can be directed to atbcls@direct.ca. The manual version you are viewing may not be a final version (see Overview for a compilation date). Some aspects of program behaviour were gleaned from experimentation and from the source code for version 1.11 (Open Source version); please forgive any incorrect information or oversights!


Using SEARCH effectively

Diagram Designer | Using Search Effectively

The Diagram Designer user manual contains information about Diagram Designer and its use. The manual is organized into topics and pages, but it may sometimes be difficult to find the right information! The manual's SEARCH tab can help in this regard, but SEARCH has more power than is evident on the surface. Following are some hints for using SEARCH effectively.

use HIGHLIGHT | On the menu bar, click Options and make sure that the Search Highlight feature is ON. If the menu item says "Search Highlight Off", then the feature is already enabled. This feature will highlight items in the text that are found by the search.
use WILDCARDS The search utility normally looks for words (or phrases) as-is. This means that a search for the word divide will not find any occurrences of the word divides! Use wildcards to expand your search:
* | including an asterisk (ie. *) somewhere in the search target finds more combinations of the target, just as it does from a DOS (or Command) prompt. Using divide* as the target finds divide, divided and divides as well.
? | including a question mark somewhere in the search target finds any character in that position. Using divide? as the target finds divides, divider and divides but won't find divide or dividing.
use PHRASES | Searching for program session finds occurrences of both words in the same topic, but not necessarily together! Using "program session" (enclosed in double quotes) treats it as a phrase and only finds that phrase. Quotes cannot be found using the search, since they enclose a phrase. Note that when searching for file names with extensions (eg. DiagramDesigner.chm), use a phrase also (eg. "DiagramDesigner.chm") otherwise the period will separate the search into 2 distinct words.
use BOOLEANS If you are looking for more than one word (or phrase), you may separate them with one of the reserved boolean words to restrict your search:
AND | Topics must contain both words, eg. help AND "pop-up" will only find topics containing both words or phrases. Note that help AND "pop-up" is equivalent to help "pop-up".
OR | Topics may contain either word or both words. Searching for object OR shape finds topics containing either or both of the words, anywhere in the topic.
NOT | Topics may contain the first word or phrase, but not the second, as in object NOT shape, which will find occurrences of macro, providing shape is not found on the page.
NEAR | Topics must contain both words or phrases, but close together. A search for object NEAR shape will find phrases containing both words, but will not find pages where the words are far apart. This search mode is not effective where pages/topics are short, since close together and far apart are not precise terms; NEAR works best on larger documents or pages.